﻿Global hFont.l
Global s.s
Global boxw.l
Global textcolor.l

Global FontName$="Arial"   ; set initial font  (could also be blank)
Global FontSize.l=32       ; set initial size  (could also be null)
Global fontbold.l=1

Enumeration
  #menu_text_color
  #menu_font
  #menu_quit
EndEnumeration

Procedure WndProc(hwnd, msg, wParam, lParam) 
  result = #PB_ProcessPureBasicEvents
  Select msg 
    Case #WM_TIMER
      s.s=FormatDate("%hh:%ii:%ss", Date())
      PostMessage_(hwnd,#WM_PAINT,0,0)
    Case #WM_PAINT
      ps.PAINTSTRUCT
      rc.RECT
      rcRegion.RECT
      hRegion.l
      BeginPaint_(hwnd,@ps)
      SelectObject_(ps\hdc,hFont)
      
      GetClientRect_(hwnd,@rc)
      ts.SIZE
      GetTextExtentPoint32_(ps\hdc,@s,Len(s),@ts)
      ResizeWindow(0,WindowX(0),WindowY(0),ts\cx,ts\cy)
      
      BeginPath_(ps\hdc)
      DrawText_(ps\hdc,@s,Len(s),@rc,0)
      EndPath_(ps\hdc)

      DeleteObject_(hRegion)
      hRegion=PathToRegion_(ps\hdc)
      ;----------------------------------------
      EndPaint_(hwnd,@ps)
      GetRgnBox_(hRegion,@rcRegion)
      rg.l=CreateRectRgnIndirect_(@rcRegion)
      CombineRgn_(hRegion,hRegion,rg,#RGN_XOR)
      DeleteObject_(rg)
      
      SetWindowRgn_(hwnd,hRegion,1)
      
  EndSelect 
  ProcedureReturn result 
EndProcedure 

If OpenWindow(0,0,0,3,2,"tclock",#PB_Window_BorderLess | #PB_Window_SystemMenu ! #PB_Window_TitleBar)
  
  hFont = CreateFont_(72,0,0,0,#FW_BOLD,0,0,0,0,0,0,0,0,"arial");48*2
  CreatePopupMenu(0)
  MenuItem(#menu_text_color, "TextColor..")
  MenuItem(#menu_font, "Font..")
  MenuBar()
  MenuItem(#menu_quit, "Quit")

  hIcon.l=LoadIcon_(GetModuleHandle_(0),1)
  AddSysTrayIcon(1,WindowID(0),hIcon)
  SysTrayIconToolTip(1,"Transparent clock")
  ;?msg = RegisterWindowMessage_("DKs_k8D_h00K")

  textcolor=RGB(0,255,0)
  SetWindowColor(0, textcolor)
  SetWindowPos_(WindowID(0),#HWND_TOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE)
  SetWindowCallback(@WndProc())
  
  SetTimer_(WindowID(0),1,500,0)
  HideWindow(0,0)
  
  Quit=0
  Repeat
    EventID = WaitWindowEvent()
    
    Select EventID
      Case #WM_LBUTTONDOWN 
        SendMessage_(WindowID(0), #WM_NCLBUTTONDOWN, #HTCAPTION, 0) 
        
      Case #PB_Event_Menu
        Select EventMenu()
          Case #menu_font:
            Result = FontRequester(FontName$, FontSize, #PB_FontRequester_Effects)
            If Result
              FontName$=SelectedFontName()
              FontSize=SelectedFontSize()
              If SelectedFontStyle() & #PB_Font_Bold
                fontbold=1
              Else
                fontbold=0
              EndIf
              If OpenPreferences("tc.ini")
                PreferenceGroup("general")
                WritePreferenceString("fontname",FontName$)
                WritePreferenceLong("fontsize",FontSize)
                WritePreferenceLong("fontbold",fontbold)
              EndIf
              
              If hfont
                DeleteObject_(hFont)
                hFont = CreateFont_(FontSize,0,0,0,#FW_BOLD*fontbold,0,0,0,0,0,0,0,0,FontName$)
              EndIf
            EndIf
            
          Case #menu_text_color:
            Color = ColorRequester()
            If Color > -1
              textcolor=color
              SetWindowColor(0, textcolor)
              If OpenPreferences("tc.ini")
                PreferenceGroup("general")
                WritePreferenceLong("clockcolor",textcolor)
              EndIf
            EndIf
          Case #menu_quit: Quit = 1

        EndSelect
      Case #PB_Event_SysTray
        If EventType() = #PB_EventType_RightClick
          DisplayPopupMenu(0, WindowID(0))
        EndIf
      Case #PB_Event_CloseWindow
        Break; Quit = 1
    EndSelect
  Until Quit = 1
  
  DeleteObject_(hFont)
  KillTimer_(WindowID(0),1)
  If CreatePreferences("tc.ini")
    PreferenceGroup("general")
    WritePreferenceLong("clockcolor",textcolor)
    WritePreferenceString("fontname",FontName$)
    WritePreferenceLong("fontsize",FontSize)
    WritePreferenceLong("fontbold",fontbold)
  EndIf
EndIf
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 61
; FirstLine = 52
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = clock00.ico
; Executable = tc.exe